#include "iRRAM_limit_templates.h"

#include <sys/time.h>
#include <sys/resource.h>

double cputime(){
 struct rusage r;
 getrusage (RUSAGE_SELF,&r);
 return r.ru_utime.tv_sec+0.000001*r.ru_utime.tv_usec;
 }

double s1,s2;
void timecheck(string s){
s2=cputime();cerr <<"    "<<1000*(s2-s1)<<" ms "<<s<<"\n";s1=cputime();
};


// to give the programs a hint on the necessary presicion:
void hint(int N){approx(REAL(1)/3,int(-N*3.322));}



// print a value x int the forms necessary for the Nijmegen competition

void nij_print_a(const REAL& x,int N, int n){
// print N digits of x after the decimal point

// the value n should be a  resonable number with
// 10^n ~ x in order to avoid unneccessary iterations. 
n=n+10;
int exp;
int round;
string s="",r="";
while (true){
	s=swrite(x,N+n);
	if ( s[1]!='.' ){exp=-N;break;} // output very small, i.e. ~0
	exp=atoi(s.substr(N+n-5,N+n).c_str());

	if ( exp<n-8 ){
		round=N+n-4;
		while (s[round]!= 'E') round--;
		round--;
//		cerr<< s<< " "<<round<<" "<<s[round]<<"\n";
		if ( (s[round]!='9')&& (s[round]!='0') )break;
		if ( (s[round-1]!='9')&& (s[round-1]!='0') )break;
		if ( (s[round-2]!='9')&& (s[round-2]!='0') )break;
	}
	n= n+exp+10;
}
//cerr<< exp<<" a "<<s<<"\n";

if (exp>=1){
	r=s.substr(exp+2,N);
}else if (exp > -N) { 
	for (int i=-1;i>= exp;i--)r+="0";
	r+=s.substr(2,N+exp);
} else {
	for (int i=1;i<= N;i++)r+="0";
}
cout << r<<"\n";
}


void nij_print_b(const REAL& x,int N){
// print N digits of x, counting from the leftmost nonzero digit

string s=swrite(x,N+11,iRRAM_float_relative);
cout << s.substr(2,N)<<"\n";
}

void nij_print_c(const REAL& x,int N, int n){
// print N digits of x after the decimal point
// the  error may be of the 1ulp type 

int round,pos,len;
string s="",r="";
int e;
//cout << -int(N*3.322)-1<<"bbbb\n";
continous_begin();
// to get a first approximation of result
// this will be fine unless the value is large.
// for small values, the precision N is already ok
s=swrite(x,N+n+11);
if (bound(x,-int(N*3.322)-1))  {
  e=-N;
} else { 
  int sz=size(x);
  if ( sz>0 ) len=N+int(size(x)*0.30102)+11;
  else len=N+11;
  if (len > N+n+11) s=swrite(x,len);
  else len=N+n+11;
  if (s[0]==' ') {e=-N;} else
  {
//cout <<s<<"------"<<len<<"---";
    pos=len-1;
    while (s[pos]!= 'E') pos--;
//cout <<s.substr(pos+1,len-pos-1)<<"\n";
    e=atoi(s.substr(pos+1,len-pos+1).c_str());
  }
}
//cerr<< e<<" c "<<s<<"\n";
if (e>=1){
	r=s.substr(e+2,N);
}else if (e > -N) { 
	for (int i=-1;i>= e;i--)r+="0";
	r+=s.substr(2,N+e);
} else {
	for (int i=1;i<= N;i++)r+="0";
}
continous_end();
cout << r<<"\n";
}


//********************************************************


typedef int EXPtype;
template <class PARAM> REAL generic_fixpoint2r  
         ( REAL F(const PARAM&,  const REAL& )
         , const REAL& z_1, const EXPtype& eps_1
         , const EXPtype& ls
         , const PARAM& param ) {
  ITERATION_STACK SAVED_STACK;
  ACTUAL_STACK.inlimit+=1;
  REAL z_new,z_old;
   if (SAVED_STACK.actual_prec > eps_1) {
     sizetype error, z_error;
     sizetype_set(error,1,SAVED_STACK.actual_prec-1);
     z_1.geterror(z_error);
     if (sizetype_less(error,z_error) ) REITERATE(0);
     z_new= z_1;
   } else {
     ACTUAL_STACK.actual_prec = (SAVED_STACK.actual_prec -ls -4)/2;
// we also reduce the increment
     ACTUAL_STACK.prec_inc=ACTUAL_STACK.actual_prec-iRRAM_starting_prec;

     z_old = generic_fixpoint2r(F,z_1,eps_1,ls,param);
// The result from this recursive call MUST have a distance to the fixpoint
// of at most 2^(ACTUAL_STACK.actual_prec) for the current value of the precision
// (the interval(!) must have this distance)
// So we can take the midpoint to proceed: 
    sizetype error;
    sizetype_exact(error);
    z_old.seterror(error);

// Now we compute a new approximation to the fixpoint.
// As the iteration function can be arbitratily bad, we may have to iterate
// the evaluation of F until the resulting precision is good enough.

// First we increase the working precision by a small amount
      ACTUAL_STACK.prec_inc=SAVED_STACK.prec_inc+iRRAM_prec_inc1;
      ACTUAL_STACK.actual_prec=iRRAM_starting_prec+ACTUAL_STACK.prec_inc;

    DEBUG1(2,"starting iteration...\n");
    DEBUG2(2,"trying to compute iteration with precision %d...\n",ACTUAL_STACK.actual_prec);
    while (1) {
       try{
// Here the actual evaluation of F happens
        z_new = F(param, z_old);
// now we check whether the new result is precise enough
        sizetype error, z_error;
        sizetype_set(error,1,SAVED_STACK.actual_prec-2);
        z_new.geterror(z_error);
        if (sizetype_less(error,z_error) ) {
      ACTUAL_STACK.prec_inc=int(ACTUAL_STACK.prec_inc * ACTUAL_STACK.prec_factor)+iRRAM_prec_inc1;
      ACTUAL_STACK.actual_prec=iRRAM_starting_prec+ACTUAL_STACK.prec_inc;
          DEBUG2(2,"iteration result too imprecise, trying a new iteration with %d...\n",ACTUAL_STACK.actual_prec);
       } else {
          DEBUG2(2,"getting result with local error 2^(%d)\n",SAVED_STACK.actual_prec);
          break;    
       }
    }
    catch ( Iteration it){
      ACTUAL_STACK.prec_inc=int(ACTUAL_STACK.prec_inc * ACTUAL_STACK.prec_factor)+iRRAM_prec_inc1;
      ACTUAL_STACK.actual_prec=iRRAM_starting_prec+ACTUAL_STACK.prec_inc;
      DEBUG2(2,"iteration failed, increasing precision locally to %d...\n",ACTUAL_STACK.actual_prec);
    } 
  }
  sizetype_set(error,1,SAVED_STACK.actual_prec-1);
  z_new.adderror(error); 
  return z_new;
}
};



//********************************************************

static int static_root;
bool all_true(const REAL& x){return true;}
REAL static_xroot;


REAL n_root_iterate(const int&n, const REAL&z) {
   return z+(static_xroot/power(z,n-1)-z)/n;
};

REAL n2_root_approx(const REAL& x) {
   int n=static_root; static_xroot=x;
   double xd=x;
   REAL y=exp(log(xd)/n);
   return generic_fixpoint2r<int>(n_root_iterate,y,-10,1,n);
}


REAL n_root_approx (int prec, const REAL& x){
//cerr<< "prec: "<<prec<<"\n";
  int n=static_root;
  if (bound(x, n*prec) ) return 0;
  REAL y;
  int s2=size(x)/n;
  y=scale(abs(x),-s2*n);
  y=lipschitz(n2_root_approx,2,all_true,y);
  y=scale(y,s2);
  if (x<0) return -y;
  else     return y;
};

REAL n_root (const REAL& x,int n){
 static_root=n;
 return limit(n_root_approx,x);
};


//********************************************************
REAL static_xexp;
REAL exp_iterate(const int& dummy,const REAL& z){
REAL result=z*(1-log(z+REAL(0))+static_xexp);
  return result;
}

REAL my_exp_reduction (int p, const REAL& x) {
  static_xexp=x;
/*  the following values fit if |x|<0.001 */
  REAL z_0=1+x;
  return generic_fixpoint2r<int>(exp_iterate,z_0,-20,1,42);
}



REAL my_exp_approx (int prec, const REAL& x){
  REAL xs=x/ln2();
  int s=round(xs)+1;
  int s2=0;
  xs=x-ln2()*s;
  switch (choose (abs(xs) >0.0005,abs(xs)<0.001) ){
  case 1:
	s2=size(xs)+12;
        if (s2>0) xs=scale(xs,-s2);
  }
  REAL z=limit_lip(my_exp_reduction,1,all_true,xs);
  if (s2>0) for (int i=1;i<=s2;i++) z*=z;
  return scale(z,s);
};

int my_exp_bound(const REAL& x)
{return (int)((round(x)+1)*1.443);};

REAL my_exp (const REAL& x)
{
  if ( positive(x-750001,0)  ) {fprintf(stderr,"Overflow in exp(x)\n");exit(1);} 
  continous_begin ();
  REAL y= limit_lip(my_exp_approx,my_exp_bound,x);
  continous_end ();
  return y;
};

/*********************************************************/

REAL my_tanh (const REAL& x) {
// just do a reformulation of (exp(x)-exp(-x))/(exp(x)+exp(-x));
// in order try not to work with numbers that are very large...
  continous_begin();
  REAL epx,epxi,th;
  switch (choose(x>0,true))
  { case 1:
                epxi=my_exp(-x);
                epxi=epxi*epxi;
                th= ((1-epxi)/(1+epxi));
                break;
    case 2:
                epxi=my_exp(x);
                epxi=epxi*epxi;
                th =  ((epxi-1)/(1+epxi));
                break;
  }
  continous_end();
  return th;
}
//********************************************************

REAL my_tan(const REAL&x){
  REAL pi1=pi();
  REAL x_red=modulo(x,pi1);
  REAL s=sin(x_red);

  pi1=scale(pi1,-1);

  if ( (x_red>-pi1)|| (x_red<pi1) ) {
    return s/sqrt(1-s*s);
  } else{
    return -s/sqrt(1-s*s);
  }
}
//********************************************************

REAL static_x;

REAL atan_iterate(const int& dummy,const REAL& z){
  REAL s=sin(z);
  REAL c2=1-s*s;
  REAL c=sqrt(c2);
  return z-(s-static_x*c)*c;
}

REAL my_atan_reduction (const REAL& x) {
//only applied for |x|<1.1
  static_x=x;
  return generic_fixpoint2r<int>(atan_iterate,x-x*x*x/3+x*x*x*x*x/5,-5,0,42);
}


REAL my_atan (const REAL& x) {
// arbitrary parameter x
  REAL result;
  continous_begin();
  switch (choose( x<-1,x>1,abs(x)<REAL(1.1)))
  { case 1:
		result= -(pi()/2 - my_atan(-1/x));
		break;
    case 2:
		result=   pi()/2 - my_atan(1/x);
		break;
    case 3:
		result= lipschitz(my_atan_reduction,1,all_true,x);
		break;
  }
 continous_end();
 return result;
}

REAL my_asin (const REAL& x){
   return my_atan(x/sqrt(1-x*x));
};

//********************************************************
static int my_euler_scale;
REAL my_euler_approx2 (int prec)
{
  if ( prec >= 2 ) return 0;
    REAL z=1,y=z,s=0;
    int i=1,j=100;
    while ( !bound(y,prec-1) ) {
      y=scale(y/i,-my_euler_scale);
      s=s+y;
      i+=1;
      if (i==j){z=z+s;s=0;j=2*j;}
    }
  z=z+s;s=0;
  return z;
};

REAL my_euler_approx1 (int prec)
{
// my_euler_scale=-int(sqrt(-1.0*prec)); 
 my_euler_scale=int(0.07*sqrt(-1.0*prec));
 if (prec < -1000000 ) my_euler_scale=int(0.12*sqrt(-1.0*prec));
 REAL x=limit(my_euler_approx2);
 for (int i=1;i<=my_euler_scale;i++) x=x*x;
 return x;
};

REAL my_euler2 ()
{
          return limit(my_euler_approx1);
};

//********************************************************


inline void continuous_begin (){ACTUAL_STACK.inlimit+=1;};
inline void continuous_end   (){ACTUAL_STACK.inlimit-=1;};
